     h nomain BNDDIR('PROGBAR')

     fprogbarfm cf   e             workstn USROPN
     f                                     infds(scr_infds)

      /copy qrpglesrc,progbarpr
     d pos             s              3  0
     d bars            S                   like(prog) inz(*ALLx'4f')
     d rtnVal          S              1N
     d scr_close       S              1N
     d barCount        S             10I 0
     dscr_infds        ds
     d scr_open                9      9N
     PdisplayProgressBar...
     P                 B                   EXPORT

     ddisplayProgressBar...
     d                 PI             1N
     d barObjPtr                       *
     d objProgBar      DS                  based(barObjPtr) Likeds(prgBars)
      /free
         if not scr_open;
           open progbarfm;
           scr_close = *ON;
         endif;
         // create new bar
         if objProgBar.barActive;
           COLOR = objProgBar.Color;
           sline = objProgBar.WindowTop;
           title = objProgBar.WindowTitle;
           if title = '';
             title = 'Progress Bar';
           endif;
           pos = (objProgBar.Percent/100)*75;
           prog = %subst(bars: 1: pos);
           status = objProgBar.StatusMessage;
           if pos<1;
              pos = 1;
           endif;
           if objProgBar.ShowPercent = *ON;
             %subst(PROG:37:4) = %EDITW(objProgBar.Percent:'  0%');
           endif;
           %subst(PROG:pos:1) = x'24';
           write progbarw;
         endif;
         if scr_close;
           close progbarfm;
         endif;
         Return rtnVal;
      /end-free
     PdisplayProgressBar...
     P                 e

     P createProgressBar...
     P                 B                   EXPORT

     d createProgressBar...
     d                 PI              *
     d rtnVal          S               *
     d ix              S              5  0
      /free
       rtnval = *NULL;
       for ix = 1 to %elem(prgBars);
         if not prgBars(ix).barActive;
           prgBars(ix).barActive = *ON;
           prgBars(ix).barIndex = ix;
           rtnval = %addr(prgBars(ix));
           leave;
         endif;
       endfor;
       if not scr_open;
         open progbarfm;
       endif;
       return rtnVal;
      /end-free
     p createProgressBar...
     P                 E

     P destroyProgressBar...
     P                 B                   EXPORT

     d destroyProgressBar...
     d                 PI
     d barObjPtr                       *
     d lclBar          DS                  BASED(barObjPtr) likedS(prgBars)
     d
     d rtnVal          S              1N
     d ix              S              5  0
     d activeBars      S              1N
      /free
        activeBars = *OFF;
        if barObjPtr <> *NULL;
          lclBar.barActive = *OFF;
          for ix = 1 to %elem(prgBars);
            if prgBars(ix).barActive;
              activeBars = *ON;
            endif;
          endfor;
          if scr_open and not activeBars;
            close progbarfm;
            *INLR = *ON;
          endif;
        endif;
        return;
      /end-free
     P destroyProgressBar...
     P                 e 