  * Subprocedure prototypes for PROGBAR service program.                 
  *                                                                      
  *   These prototypes are used to create and display a progress bar     
  *   within an RPGLE program.                                           
  *                                                                      
                                                                         
  * Constants                                                            
 d COLOR_RED       c                   CONST(x'A9')                      
 d COLOR_WHITE     c                   CONST(x'A3')                      
 d COLOR_BLUE      c                   CONST(x'BB')                      
 d COLOR_PINK      c                   CONST(x'B9')                      
 d COLOR_GREEN     c                   CONST(x'A1')                      
                                                                         
  * Display a previously defined progress bar                            
 ddisplayProgressBar...                                                  
 d                 PR             1N                                     
 d barObjOPtr                      *                                     
                                                                         
  * Create a new progress bar                                            
 d createProgressBar...                                                  
 d                 PR              *                                     
                                                                         
  * Remove a previously created progress bar                             
 d destroyProgressBar...                                                 
 d                 PR                                                    
 d barObjPtr                       *                                     
                                                                         
 d prgBars         DS                  dim(10) qualified                 
 d  barActive                     1N                                     
 d  barIndex                      5  0                                   
 d  Percent                       3  0 inz(0)                            
 d  StatusMessage                75                                      
 d  WindowTitle                  20                                      
 d  Color                         1A   inz(COLOR_GREEN)                   
 d  ShowPercent                   1N   Inz(*ON)                     
 d  WindowTop                     2  0 inz(1)                       
 d  Index                         5  0                              